/*
  Copyright (C) 2009 Gary Briggs <chunky@icculus.org>

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Gary Briggs <chunky@icculus.org>

*/



#ifndef __V1CS_H
#define __V1CS_H

#include <getopt.h>

#define V1CS_DEFAULT_DEVICE "/dev/ttyUSB1"

static const struct option longopts[] = {
	{ "help", no_argument, NULL, 'h' }, ///< Print the help text
	{ "version", no_argument, NULL, 'v' }, ///< Print the version text
	{ "on", no_argument, NULL, '1' }, ///< Turn device on
	{ "off", no_argument, NULL, '0' }, ///< Turn device off
	{ "mode", no_argument, NULL, 'o' }, ///< Change mode
	{ "mute", no_argument, NULL, 'm' }, ///< Mute
	{ "listen", no_argument, NULL, 'l' }, ///< Listen
	{ "device", required_argument, NULL, 'd' }, ///< Open this device
	{ NULL, 0, NULL, 0 } ///< End
};

/// getopt() short options
static const char shortopts[] = "hv01";

int v1cs_open(const char *dev);
void v1cs_close(int fd);

void v1cs_on(int fd);
void v1cs_off(int fd);
void v1cs_mode(int fd);
void v1cs_mute(int fd);

int v1cs_listen(int fd, int firstcall,
	int *loud, int *strength,
	int *ledX, int *ledK, int *ledKA, int *ledLaser,
	int eightsegment[8],
	int *frontarrow, int *sidearrow, int *reararrow);

void printhelp(const char *argv0);
void printversion();

#endif //__V1CS_H

